/* $Id: cmd_helper.h 19605 2010-04-11 15:44:16Z frosch $ */

/*
 * This file is part of OpenTTD.
 * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
 * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
 */

/** @file cmd_helper.h Helper functions to extract data from command parameters. */

#ifndef CMD_HELPER_H
#define CMD_HELPER_H

#include "core/enum_type.hpp"

template<typename T, uint N, typename U> static inline T Extract(U v)
{
	/* Check if there are enough bits in v */
	assert_tcompile(N + EnumPropsT<T>::num_bits <= sizeof(U) * 8);
	assert_tcompile(EnumPropsT<T>::end <= (1 << EnumPropsT<T>::num_bits));
	return (T)GB(v, N, EnumPropsT<T>::num_bits);
}

#endif
